unit Unit2;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, ComCtrls;

type

  { TfrmChild }

  TfrmChild = class(TForm)
    btnDocked: TButton;
    btnUnDocked: TButton;
    StaticText1: TStaticText;
    procedure btnDockedClick(Sender: TObject);
    procedure btnUnDockedClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private

  public

  end;

const
  DockText: String = 'It''s the docked window';
  UnDockText: String = 'It''s the undocked window';
var
  frmChild: TfrmChild;

implementation

uses
  Unit1;

{$R *.lfm}

{ TfrmChild }

procedure TfrmChild.btnDockedClick(Sender: TObject);
begin
  with frmMain do
  begin
    btnUnDocked.Enabled:= True;
    //FormStyle:= fsMDIForm;
    ShowOnTop;
    PgCtrl.AddTabSheet;
    PgCtrl.ActivePageIndex:= Pred(PgCtrl.PageCount);
    NewTabSheetIndex:= PgCtrl.ActivePageIndex;
    PgCtrl.Pages[NewTabSheetIndex].Caption:= frmChild.Caption;
    FrmChildWidth:= frmChild.Width;
    FrmChildHeight:= frmChild.Height;
    FrmChildLeft:= frmChild.Left;
    FrmChildTop:= frmChild.Top;
  end;

  with frmChild do
  begin
    //FormStyle:= fsMDIChild;
    BorderStyle:= bsNone;
    Align:= alClient;
    Parent:= frmMain.PgCtrl.Pages[frmMain.NewTabSheetIndex];
    Visible:= True;
    btnDocked.Enabled:= not btnDocked.Enabled;
    StaticText1.Caption:= DockText;
  end;

end;

procedure TfrmChild.btnUnDockedClick(Sender: TObject);
begin
  if frmMain.PgCtrl.PageCount > 0 then
  begin
    with frmChild do
    begin
      //FormStyle:= fsMDIForm;
      BorderStyle:= bsSizeable;
      Align:= alNone;
      Parent:= nil;
      Left:= frmMain.FrmChildLeft;
      Top:= frmMain.FrmChildTop;
      Width:= frmMain.FrmChildWidth;
      Height:= frmMain.FrmChildHeight;
      //FormStyle:= fsMDIForm;
      btnDocked.Enabled:= not btnDocked.Enabled;
      StaticText1.Caption:= UnDockText;
    end;

    btnUnDocked.Enabled:= not btnUnDocked.Enabled;
    frmMain.PgCtrl.Pages[frmMain.NewTabSheetIndex].Free;
  end;
end;


procedure TfrmChild.FormCreate(Sender: TObject);
begin
  with frmChild do
  begin
    Left:= frmMain.Left + (frmMain.Width - Width) div 2;
    Top:= frmMain.Top + (frmMain.Height - Height) div 2;
    btnDocked.Enabled:= True;
    btnUnDocked.Enabled:= False;
    StaticText1.Caption:= UnDockText;
    ShowInTaskBar:= stAlways;
  end;
end;

end.

